-----------------------------------------------------------------------------------------
-- Start Activity
-----------------------------------------------------------------------------------------
function SmashAndGrab:StartActivity()
   	print("START! -- SmashAndGrab:StartActivity()!");
   	-- Set up teams
   	-- Team 2 is always CPU
   	self.CPUTeam = Activity.TEAM_2;
	self.PlayerTeam = Activity.TEAM_1;
	self.RogueTeam = -1;

	self.AreaBridgeAlert = SceneMan.Scene:GetArea("BridgeAlert");
	self.AreaSniperLeft = SceneMan.Scene:GetArea("SniperLeft");
	self.AreaSniperRight = SceneMan.Scene:GetArea("SniperRight");
	self.AreaLeftAssaultDrop = SceneMan.Scene:GetArea("LeftAssaultDrop");
	self.AreaRightAssaultDrop = SceneMan.Scene:GetArea("RightAssaultDrop");
	self.AreaLeftSniperDrop = SceneMan.Scene:GetArea("LeftSniperDrop");
	self.AreaRightSniperDrop = SceneMan.Scene:GetArea("RightSniperDrop");

	self.AreaLeftBridgeDoorCheck = SceneMan.Scene:GetArea("LeftBridgeDoorCheck");
	self.AreaRightBridgeDoorCheck = SceneMan.Scene:GetArea("RightBridgeDoorCheck");

	self.AreaSniperRight2 = SceneMan.Scene:GetArea("SniperRight2");
	self.AreaAssaultDrop = SceneMan.Scene:GetArea("AssaultDrop");
	self.AreaBunker = SceneMan.Scene:GetArea("Bunker");

	self.AreaTerminal = SceneMan.Scene:GetArea("Terminal");
	self.AreaTeleport = SceneMan.Scene:GetArea("Teleport");
	self.AreaBunkerDrop = SceneMan.Scene:GetArea("BunkerDrop");
	self.AreaBunkerEscapeDrop = SceneMan.Scene:GetArea("BunkerEscapeDrop");
	
	self.braindead = {};
	self.AssignedBrains = {};
	self.MOIDLimit = 190;
    
    self.GenericTimer = Timer();
    self.GenericTimer:Reset();
	
	self.TeleportEffectTimer = Timer();
	self.TeleportEffectTimer:Reset();
	
    self.FightPhase = { SNEAKIN = 1 , ALERT = 2 , ASSAULT = 3 , ESCAPE = 4 };
    self.CurrentFightPhase = self.FightPhase.SNEAKIN;

	-- No money and alive reinforcements availabe for player according to the plot
	self.PlayerGold = 1500; -- Player starting credits
    
    for player = 0, self.PlayerCount - 1 do
        -- Check if we already have a brain assigned
        if not self:GetPlayerBrain(player) then
			self.braindead[player] = false;
			local brain = CreateAHuman("Dafred Brain SmashAndGrab" , "SmashAndGrab.rte");
			
			
			brain.Pos = Vector(30 + player * 20, 560); -- Gameplay
			brain.AIMode = Actor.AIMODE_SENTRY;
			brain.Team = self.PlayerTeam;
			brain:AddInventoryItem(CreateHDFirearm("M16" , "Ronin.rte")); -- Gameplay
			brain:AddInventoryItem(CreateHDFirearm("Uzi" , "Ronin.rte")); -- Gameplay
			--[[brain:AddInventoryItem(CreateHDFirearm("Arc Gun" , "D9.rte")); -- Debug
			brain.Pos = Vector(3300 + player * 20, 560); -- Debug only
			brain:AddInventoryItem(CreateHDFirearm("Auto Shotgun" , "Coalition.rte")); -- Debug
			brain:AddInventoryItem(CreateHDFirearm("Heavy Digger" , "Base.rte")); -- Debug
			brain:AddInventoryItem(CreateTDExplosive("Cluster Grenade" , "Coalition.rte")); -- Debug
			brain:AddInventoryItem(CreateTDExplosive("Cluster Grenade" , "Coalition.rte")); -- Debug
			brain:AddInventoryItem(CreateTDExplosive("Cluster Grenade" , "Coalition.rte")); -- Debug
			brain:AddInventoryItem(CreateTDExplosive("Cluster Grenade" , "Coalition.rte")); -- Debug
			brain:AddInventoryItem(CreateTDExplosive("Cluster Grenade" , "Coalition.rte")); -- Debug
			brain:AddInventoryItem(CreateTDExplosive("Cluster Grenade" , "Coalition.rte")); -- Debug
			brain:AddInventoryItem(CreateTDExplosive("Artifact" , "SmashAndGrab.rte")); -- Debug ]]--
			brain:AddInventoryItem(CreateHDFirearm("Medium Digger" , "Base.rte")); -- Gameplay
			self.AssignedBrains[player] = brain;
            -- Let the spawn into the world, passing ownership
            MovableMan:AddActor(brain);
            -- Set the found brain to be the selected actor at start
            self:SetPlayerBrain(brain, player);
            SceneMan:SetScroll(self:GetPlayerBrain(player).Pos, player);
            self:SetLandingZone(self:GetPlayerBrain(player).Pos, player);
            -- Set the observation target to the brain, so that if/when it dies, the view flies to it in observation mode
            self:SetObservationTarget(self:GetPlayerBrain(player).Pos, player);
        end
    end

	-- Spawning
	self.DropshipSpawnInterval = 16000;
	self.DropshipSpawnTimer = Timer();
	self.DropshipSpawnTimer:Reset();
	
    self.SpawnPos = { LEFT = 1 , RIGHT = 2};
    self.SpawnType = { SNIPER = 1 , ASSAULT = 2};

	self.CoalitionLightWeapons = {"Shotgun" , "Compact Assault Rifle" , "Flamer"};
	self.CoalitionMediumWeapons = {"Shotgun" , "Assault Rifle" , "Sniper Rifle"};
	
	-- Artifact specific
	self.ArtifactExtracted = false;

	-- Teleport boot
	self.ChunksComplete = 0;
	self.TotalChunks = 100;
	self.ChunkInterval = 200;
	
	self.TeleportActive = false; -- Flags if teleport is online
	self.TeleportEffectAsc = true; -- Flags if we need to show ascending teleport effect
	self.StartTeleportEffect = false; -- Flags if we must start new teleport effect
	self.BSOD = false; -- Flags if we'll have a guranteed BSOD on terminal
	self.BootRetries = 0;
	self.MaxBootRetries = 10; -- About 200 secs of guaranteed boot wait time
	
	-- Ronin squad
	local ronin;
	
	ronin = CreateAHuman("Dimitri" , "Ronin.rte");
	ronin.Pos = Vector(40 , 420);
	ronin.Team = self.PlayerTeam;
	ronin:AddInventoryItem(CreateHDFirearm("Sniper Rifle" , "Ronin.rte"));
	ronin:AddInventoryItem(CreateHDFirearm("Uzi" , "Ronin.rte"));
	ronin:AddInventoryItem(CreateHDFirearm("Medium Digger" , "Base.rte"));
    MovableMan:AddActor(ronin);

	ronin = CreateAHuman("Brutus" , "Ronin.rte");
	ronin.Pos = Vector(150 , 560);
	ronin.Team = self.PlayerTeam;
	ronin:AddInventoryItem(CreateHDFirearm("Rifle Long" , "Ronin.rte"));
	ronin:AddInventoryItem(CreateHDFirearm("Bazooka" , "Ronin.rte"));
	ronin:AddInventoryItem(CreateHDFirearm("TommyGun" , "Ronin.rte"));
    MovableMan:AddActor(ronin);
	
	self.ScreenActivated = false;

	-- Debug only
	--[[self.TeleportScreen = CreateAEmitter("Boot Screen");
	self.TeleportScreen.Pos = Vector(3735 , 716);
	self.TeleportScreen:EnableEmission(true);
	MovableMan:AddParticle(self.TeleportScreen);]]--
	
    -- Set up AI modes for the Actors that have been added to the scene by the scene definition
    for actor in MovableMan.AddedActors do
		actor.AIMode = Actor.AIMODE_SENTRY;
    end

    for actor in MovableMan.Actors do
		actor.AIMode = Actor.AIMODE_SENTRY;
    end

    -- Set the team's funds.
    self:SetTeamFunds(self.PlayerGold,self.PlayerTeam);
end
-----------------------------------------------------------------------------------------
-- Pause Activity
-----------------------------------------------------------------------------------------
function SmashAndGrab:PauseActivity(pause)
    print("PAUSE! -- SmashAndGrab:PauseActivity()!");
end

-----------------------------------------------------------------------------------------
-- End Activity
-----------------------------------------------------------------------------------------
function SmashAndGrab:EndActivity()
    print("END! -- SmashAndGrab:EndActivity()!");
end
-----------------------------------------------------------------------------------------
-- Skip phases
-----------------------------------------------------------------------------------------
function SmashAndGrab:SkipPhases()
	if self.CurrentFightPhase == self.FightPhase.SNEAKIN then
		self:AdvanceToAlert();
	elseif self.CurrentFightPhase == self.FightPhase.TOTALALERT then
		self:AdvanceToEscape();
	end
end
-----------------------------------------------------------------------------------------
-- Check if we extracted and lost artifact. Game will over if so.
-----------------------------------------------------------------------------------------
function SmashAndGrab:CheckArtifact()
	local artlaying = false;
	local artheld = false;

	if not self.ArtifactExtracted then
		for item in MovableMan.Items do
			if item.PresetName == "Artifact" then
				self.ArtifactExtracted = true;
				artlaying = true;
			end -- if
		end -- for

		self:AddObjectivePoint("SMASH!!!", Vector(1043 , 780 - 20), self.PlayerTeam, GameActivity.ARROWDOWN);
	else
		for item in MovableMan.Items do
			if item.PresetName == "Artifact" then
				self:AddObjectivePoint("GRAB!!!", item.AboveHUDPos, self.PlayerTeam, GameActivity.ARROWDOWN);
				artlaying = true;
			end -- if
		end -- for
		
		for actor in MovableMan.Actors do
			if actor:HasObject("Artifact") then
				artheld = true;
			end
		end -- for
		
		if not artlaying and not artheld then
			-- Game over
			if self.ActivityState ~= Activity.OVER then
				self.WinnerTeam = self.CPUTeam;
				ActivityMan:EndActivity();
			end
		end
	end
end
-----------------------------------------------------------------------------------------
-- Update Activity
-----------------------------------------------------------------------------------------
function SmashAndGrab:UpdateActivity()
   	-- Clear all objective markers, they get re-added each frame
   	self:ClearObjectivePoints();

	self:DoBrainSelection();
	self:CheckArtifact();
	
	if self.CurrentFightPhase == self.FightPhase.SNEAKIN then
		self:PhaseSneakIn();
	elseif self.CurrentFightPhase == self.FightPhase.ALERT then
		self:PhaseAlert();
	elseif self.CurrentFightPhase == self.FightPhase.ASSAULT then
		self:PhaseAssault();
	elseif self.CurrentFightPhase == self.FightPhase.ESCAPE then
		self:PhaseEscape();
	end	
	-- self:SkipPhases();

	self:YSortObjectivePoints();
end
-----------------------------------------------------------------------------------------
-- Brain selection and gameover conditions check
-----------------------------------------------------------------------------------------
function SmashAndGrab:DoBrainSelection()
	if not (self.ActivityState == Activity.OVER) then
		-- Iterate through all human players
		for player = 0, self.PlayerCount - 1 do
			-- The current player's team
			local team = self:GetTeamOfPlayer(player);
	
			-- Make sure the game is not already ending
			-- Check if any player's brain is dead
			local brain = self:GetPlayerBrain(player);
			if not brain or not MovableMan:IsActor(brain) or not brain:HasObjectInGroup("Brains") then
				self:SetPlayerBrain(nil, player);
				-- Try to find a new unasigned brain this player can use instead, or if his old brain entered a craft
				local newBrain = MovableMan:GetUnassignedBrain(team);
				-- Found new brain actor, assign it and keep on truckin'
				if newBrain and self.braindead[player] == false then
					self:SetPlayerBrain(newBrain, player);
					self:SwitchToActor(newBrain, player, team);
				else
					FrameMan:SetScreenText("Commander died!", player, 333, -1, false);
					self.braindead[player] = true;
					
					-- Now see if all brains of self player's team are dead, and if so, end the game
					if not MovableMan:GetClosestBrainActor(team) then
						self.WinnerTeam = self:OtherTeam(team);
						ActivityMan:EndActivity();
					end
				end
			else
				-- Update the observation target to the brain, so that if/when it dies, the view flies to it in observation mode
				self:SetObservationTarget(brain.Pos, player)
			end -- 
		end --for
	end
end
-----------------------------------------------------------------------------------------
-- Spawn dropship. Returns true if spawn is successfull, false otherwise
-----------------------------------------------------------------------------------------
function SmashAndGrab:SpawnBridgeDropship()
	if MovableMan:GetMOIDCount() < self.MOIDLimit then
		-- Select dropship destination and cargo
		local lefttowerempty = true;
		local righttowerempty = true;
		local spawnpos;
		local spawntype;

		-- Check for empty towers
		for actor in MovableMan.Actors do
			if actor.Team == self.CPUTeam then
				if self.AreaSniperLeft:IsInside(actor.Pos) then
					lefttowerempty = false;
				end
		
				if self.AreaSniperRight:IsInside(actor.Pos) then
					righttowerempty = false;
				end
			end
		end

		-- If towers are empty - spawn snipers
		-- else - spawn assault team
		if lefttowerempty and righttowerempty and math.random() < 0.80 then
			spawntype = self.SpawnType.SNIPER;
		else
			spawntype = self.SpawnType.ASSAULT;
		end
		
		local ship = CreateACDropShip("Drop Ship MK1" , "Base.rte");
		ship.Team = self.CPUTeam;
		ship:SetControllerMode(Controller.CIM_AI, -1);
			if spawntype == self.SpawnType.SNIPER then
				local actor = nil;
				actor = CreateAHuman("Soldier Light" , "Coalition.rte");
				if math.random() < 0.15 then
					actor:AddInventoryItem(CreateHDFirearm("Heavy Sniper Rifle" , "Coalition.rte"));
				else
					actor:AddInventoryItem(CreateHDFirearm("Sniper Rifle" , "Coalition.rte"));
				end
					
				actor:AddInventoryItem(CreateHDFirearm("Auto Pistol" , "Coalition.rte"));
				actor.Team = self.CPUTeam;
				actor.AIMode = Actor.AIMODE_GOTO;

				if math.random() < 0.5 then
					spawnpos = self.SpawnPos.LEFT;
				else
					spawnpos = self.SpawnPos.RIGHT;
				end

				if spawnpos == self.SpawnPos.LEFT then
					actor:AddAISceneWaypoint(Vector(804, 192));
					ship.Pos = Vector(self.AreaLeftSniperDrop:GetRandomPoint().X, 0);
				else
					actor:AddAISceneWaypoint(Vector(1308, 192));
					ship.Pos = Vector(self.AreaRightSniperDrop:GetRandomPoint().X, 0);
				end
				
				ship:AddInventoryItem(actor);
			else
				local actor = nil;
				
				for i = 1, 2 do
					actor = CreateAHuman("Soldier Light" , "Coalition.rte");
					if math.random() < 0.15 then
						actor:AddInventoryItem(CreateHeldDevice("Riot Shield" , "Base.rte"));
						actor:AddInventoryItem(CreateHDFirearm("Auto Pistol" , "Coalition.rte"));
						actor:AddInventoryItem(CreateTDExplosive("Incendiary Grenade" , "Coalition.rte"));
						actor:AddInventoryItem(CreateTDExplosive("Grenade" , "Coalition.rte"));
					else
						actor:AddInventoryItem(CreateHDFirearm(self.CoalitionLightWeapons[math.random(#self.CoalitionLightWeapons)] , "Coalition.rte"));
						actor:AddInventoryItem(CreateHDFirearm("Auto Pistol" , "Coalition.rte"));
						if math.random() < 0.75 then
							actor:AddInventoryItem(CreateHDFirearm("Medium Digger" , "Base.rte"));
						end
					end
					actor.Team = self.CPUTeam;
					actor.AIMode = Actor.AIMODE_BRAINHUNT;

					ship:AddInventoryItem(actor);
				end
				
				-- We have a glitch with doors when clones are unable to pass the doors so
				-- we'll have to drop clones on towers when if have undestroyed doors
				-- in towers
				local leftdoorsactive;
				local rightdoorsactive;
				
				for actor in MovableMan.Actors do
					if actor.ClassName == "ADoor" then
						if self.AreaLeftBridgeDoorCheck:IsInside(actor.Pos) then
							leftdoorsactive = true;
						end

						if self.AreaRightBridgeDoorCheck:IsInside(actor.Pos) then
							rightdoorsactive = true;
						end
					end
				end
				
				-- Drop troops to towers if both doors are not destoryed
				-- Drop troop from the side where one door is destroyed so they can pass
				-- Drop troops on either side if all doors are destroyed
				if leftdoorsactive and rightdoorsactive then
					if math.random() < 0.5 then
						ship.Pos = Vector(self.AreaLeftSniperDrop:GetRandomPoint().X, 0);
					else
						ship.Pos = Vector(self.AreaRightSniperDrop:GetRandomPoint().X, 0);
					end
				elseif leftdoorsactive and not rightdoorsactive then
					ship.Pos = Vector(self.AreaRightAssaultDrop:GetRandomPoint().X, 0);
				elseif not leftdoorsactive and rightdoorsactive then
					ship.Pos = Vector(self.AreaLeftAssaultDrop:GetRandomPoint().X, 0);
				else
					if math.random() < 0.5 then
						ship.Pos = Vector(self.AreaLeftAssaultDrop:GetRandomPoint().X, 0);
					else
						ship.Pos = Vector(self.AreaRightAssaultDrop:GetRandomPoint().X, 0);
					end
				end
			end

			MovableMan:AddActor(ship);
		return true;
	end
	return false;
end
-----------------------------------------------------------------------------------------
-- Spawn dropship. Returns true if spawn is successfull, false otherwise
-----------------------------------------------------------------------------------------
function SmashAndGrab:SpawnAssaultDropship()
	if MovableMan:GetMOIDCount() < self.MOIDLimit then
		-- Select dropship destination and cargo
		local righttowerempty = true;
		local spawntype;

		-- Check for empty towers
		for actor in MovableMan.Actors do
			if actor.Team == self.CPUTeam then
				if self.AreaSniperRight2:IsInside(actor.Pos) then
					righttowerempty = false;
				end
			end
		end

		-- If right tower is empty - spawn sniper
		-- else - spawn assault team
		if righttowerempty and math.random() < 0.80 then
			spawntype = self.SpawnType.SNIPER;
		else
			spawntype = self.SpawnType.ASSAULT;
		end
		
		
		local ship = CreateACDropShip("Drop Ship MK1" , "Base.rte");
		ship.Team = self.CPUTeam;
		ship:SetControllerMode(Controller.CIM_AI, -1);
			if spawntype == self.SpawnType.SNIPER then
				local actor = nil;
				actor = CreateAHuman("Soldier Light" , "Coalition.rte");
				if math.random() < 0.75 then
					actor:AddInventoryItem(CreateHDFirearm("Heavy Sniper Rifle" , "Coalition.rte"));
				else
					actor:AddInventoryItem(CreateHDFirearm("Sniper Rifle" , "Coalition.rte"));
				end
					
				actor:AddInventoryItem(CreateHDFirearm("Auto Pistol" , "Coalition.rte"));
				actor.Team = self.CPUTeam;
				actor.AIMode = Actor.AIMODE_GOTO;
				actor:AddAISceneWaypoint(Vector(1488, 192));

				ship.Pos = Vector(self.AreaRightSniperDrop:GetRandomPoint().X, 0);
				ship:AddInventoryItem(actor);
			else
				local actor = nil;
				
				for i = 1, 2 do
					actor = CreateAHuman("Soldier Light" , "Coalition.rte");
					if math.random() < 0.15 then
						actor:AddInventoryItem(CreateHeldDevice("Riot Shield" , "Base.rte"));
						actor:AddInventoryItem(CreateHDFirearm("Auto Pistol" , "Coalition.rte"));
						actor:AddInventoryItem(CreateTDExplosive("Incendiary Grenade" , "Coalition.rte"));
						actor:AddInventoryItem(CreateTDExplosive("Grenade" , "Coalition.rte"));
					else
						actor:AddInventoryItem(CreateHDFirearm(self.CoalitionMediumWeapons[math.random(#self.CoalitionMediumWeapons)] , "Coalition.rte"));
						actor:AddInventoryItem(CreateHDFirearm("Auto Pistol" , "Coalition.rte"));
						if math.random() < 0.75 then
							actor:AddInventoryItem(CreateHDFirearm("Medium Digger" , "Base.rte"));
						end
					end
					actor.Team = self.CPUTeam;
					actor.AIMode = Actor.AIMODE_BRAINHUNT;

					ship:AddInventoryItem(actor);
				end
			
				ship.Pos = Vector(self.AreaAssaultDrop:GetRandomPoint().X, 0);
			end

			MovableMan:AddActor(ship);
		return true;
	end
	return false;
end
-----------------------------------------------------------------------------------------
-- Spawn dropship. Returns true if spawn is successfull, false otherwise
-----------------------------------------------------------------------------------------
function SmashAndGrab:SpawnEscapeDropship()
	if MovableMan:GetMOIDCount() < self.MOIDLimit then

	local ship = CreateACDropShip("Drop Ship MK1" , "Base.rte");
		ship.Team = self.CPUTeam;
		ship:SetControllerMode(Controller.CIM_AI, -1);
			local actor = nil;
			
			for i = 1, 2 do
				actor = CreateAHuman("Soldier Heavy" , "Coalition.rte");
				if math.random() < 0.15 then
					actor:AddInventoryItem(CreateHeldDevice("Riot Shield" , "Base.rte"));
					actor:AddInventoryItem(CreateHDFirearm("Auto Pistol" , "Coalition.rte"));
					actor:AddInventoryItem(CreateTDExplosive("Incendiary Grenade" , "Coalition.rte"));
					actor:AddInventoryItem(CreateTDExplosive("Grenade" , "Coalition.rte"));
				else
					actor:AddInventoryItem(CreateHDFirearm(self.CoalitionMediumWeapons[math.random(#self.CoalitionMediumWeapons)] , "Coalition.rte"));
					actor:AddInventoryItem(CreateHDFirearm("Auto Pistol" , "Coalition.rte"));
					if math.random() < 0.75 then
						actor:AddInventoryItem(CreateHDFirearm("Heavy Digger" , "Base.rte"));
					end
				end
				actor.Team = self.CPUTeam;
				actor.AIMode = Actor.AIMODE_BRAINHUNT;

				ship:AddInventoryItem(actor);
			end
			
			if math.random() < 0.5 then
				ship.Pos = Vector(self.AreaBunkerDrop:GetRandomPoint().X, 0);
			else
				ship.Pos = Vector(self.AreaBunkerEscapeDrop:GetRandomPoint().X, 0);
			end
				

			MovableMan:AddActor(ship);
		return true;
	end
	return false;
end
-----------------------------------------------------------------------------------------
-- Do teleport effects
-----------------------------------------------------------------------------------------
function SmashAndGrab:TeleportEffect()
	if self.StartTeleportEffect then
		local effect = nil;
		if self.TeleportEffectAsc then
			if self.TeleportActive then
				effect = CreateMOSParticle("TeleportGlowHighAsc" , "SmashAndGrab.rte");
			else
				effect = CreateMOSParticle("TeleportGlowLowAsc" , "SmashAndGrab.rte");
			end
		else
			if self.TeleportActive then
				effect = CreateMOSParticle("TeleportGlowHighDesc" , "SmashAndGrab.rte");
			else
				effect = CreateMOSParticle("TeleportGlowLowDesc" , "SmashAndGrab.rte");
			end
		end
		effect.Pos = Vector(3854 , 722)
		MovableMan:AddParticle(effect);
		
		self.TeleportEffectTimer:Reset();
		self.TeleportEffectAsc = not self.TeleportEffectAsc;
		self.StartTeleportEffect = false;
	end

	if self.TeleportEffectTimer:IsPastSimMS(1960) then
		self.StartTeleportEffect = true;
	end
end
-----------------------------------------------------------------------------------------
-- Phase "Sneak in"
-----------------------------------------------------------------------------------------
function SmashAndGrab:PhaseSneakIn()
	-- Show character marks
	if not self.GenericTimer:IsPastSimMS(15000) then
		for player = 0, self.PlayerCount - 1 do
			if MovableMan:IsActor(self.AssignedBrains[player]) then
				self:AddObjectivePoint("Protect Commander", self.AssignedBrains[player].AboveHUDPos, self.PlayerTeam, GameActivity.ARROWDOWN);
			end
		end
	end
	
	-- Check if wee need to start clone panic
	for actor in MovableMan.Actors do
		if actor.Team == self.PlayerTeam then
			if self.AreaBridgeAlert:IsInside(actor.Pos) then
				self:AdvanceToAlert();
			end
		end
	end

	-- Start panic if somebody was killed
	if self:GetTeamDeathCount(self.CPUTeam) > 0 then
		self:AdvanceToAlert();
	end
end
-----------------------------------------------------------------------------------------
-- "Sneak in" -> "Total Alert"
-----------------------------------------------------------------------------------------
function SmashAndGrab:AdvanceToAlert()
	print ("Sneak in -> Alert");
    self.CurrentFightPhase = self.FightPhase.ALERT;
	self.GenericTimer:Reset();
	self.DropshipSpawnTimer:Reset();
end
-----------------------------------------------------------------------------------------
-- Phase "Total Alert"
-----------------------------------------------------------------------------------------
function SmashAndGrab:PhaseAlert()
	-- Spawn enemies
	if self.DropshipSpawnTimer:IsPastSimMS(self.DropshipSpawnInterval) then
		if self:SpawnBridgeDropship() then
			self.DropshipSpawnTimer:Reset();
		end
	end--]]--
	
	if not self.GenericTimer:IsPastSimMS(4500) then
		for player = 0, self.PlayerCount - 1 do
			self:ResetMessageTimer(player);
			FrameMan:ClearScreenText(player);
			FrameMan:SetScreenText("Outpost alerted, coalition reinforcements on the way! Hurry up!!!", player, 500, self.DropshipSpawnInterval, true);
		end
	end
	
	-- Check mission objective
	for actor in MovableMan.Actors do
		if actor:HasObject("Artifact") then
			self:AdvanceToAssault();
		end
	end
end
-----------------------------------------------------------------------------------------
-- "Alert" -> "Assault"
-----------------------------------------------------------------------------------------
function SmashAndGrab:AdvanceToAssault()
	print ("Alert -> Assault");
    self.CurrentFightPhase = self.FightPhase.ASSAULT;
	self.GenericTimer:Reset();
	
	self.DropshipSpawnInterval = 16000;
end
-----------------------------------------------------------------------------------------
-- Phase "Assault"
-----------------------------------------------------------------------------------------
function SmashAndGrab:PhaseAssault()
	-- Spawn enemies
	if self.DropshipSpawnTimer:IsPastSimMS(self.DropshipSpawnInterval) then
		if self:SpawnAssaultDropship() then
			self.DropshipSpawnTimer:Reset();
		end
	end--]]--

	self:AddObjectivePoint("Activate Teleport", Vector(3736 , 708), self.PlayerTeam, GameActivity.ARROWDOWN);
	
	-- Check mission objective
	for actor in MovableMan.Actors do
		if actor.Team == self.PlayerTeam then
			if self.AreaBunker:IsInside(actor.Pos) then
				self:AdvanceToEscape();
			end
		end
	end
end
-----------------------------------------------------------------------------------------
-- "Assault" -> "Escape"
-----------------------------------------------------------------------------------------
function SmashAndGrab:AdvanceToEscape()
	print ("Assault -> Escape");
    self.CurrentFightPhase = self.FightPhase.ESCAPE;
	self.GenericTimer:Reset();
	
	self.DropshipSpawnInterval = 16000;
end
-----------------------------------------------------------------------------------------
-- Phase "Escape"
-----------------------------------------------------------------------------------------
function SmashAndGrab:PhaseEscape()
	-- Spawn enemies
	if self.DropshipSpawnTimer:IsPastSimMS(self.DropshipSpawnInterval) then
		if self:SpawnEscapeDropship() then
			self.DropshipSpawnTimer:Reset();
		end
	end--]]--

	if not self.TeleportActive then
		-- Check current objectives
		local isinside = false;

		-- Show boot completion mark
		for actor in MovableMan.Actors do
			if actor.Team == self.PlayerTeam then
				if self.AreaTerminal:IsInside(actor.Pos) then
					-- We don't need to show boot completion mark as we don't actually know when teleport will be online
					-- We'll show mark only for debugging purposes
					-- self:AddObjectivePoint(string.format("Booting: %d%%", self.ChunksComplete / self.TotalChunks * 100), Vector(3736 , 660), self.PlayerTeam, GameActivity.ARROWUP);
					isinside = true;
				
					if not self.ScreenActivated then
						self.TeleportScreen = CreateAEmitter("Boot Screen");
						self.TeleportScreen.Pos = Vector(3735 , 716);
						self.TeleportScreen:EnableEmission(true);
						MovableMan:AddParticle(self.TeleportScreen);
						
						self.StartTeleportEffect = true;
						self.TeleportEffectTimer:Reset();						
						
						self.ScreenActivated = true;
					end
				end
			end
		end -- for
		
		-- Check boot status
		if not isinside then
			-- Reset all completion signs if we're not inside the terminal zone
			self:AddObjectivePoint("Activate Teleport", Vector(3736 , 708), self.PlayerTeam, GameActivity.ARROWDOWN);
			if MovableMan:IsParticle(self.TeleportScreen) then
				MovableMan:RemoveParticle(self.TeleportScreen);
				self.TeleportScreen = nil;
			end
			
			self.ChunksComplete = 0;
			self.ScreenActivated = false;
			self.GenericTimer:Reset();
			self.StartTeleportEffect = false;
			self.TeleportEffectTimer:Reset();
		else
			-- If we didn't activate the teleport perform BSOD probability calculation
			-- display boot process and show boot screens
			if not self.TeleportActive then
				self:TeleportEffect();
				if self.ChunksComplete < 25 then
					self:AddObjectivePoint("Booting." , Vector(3736 , 660), self.PlayerTeam, GameActivity.ARROWUP);
				elseif self.ChunksComplete < 50 then
					self:AddObjectivePoint("Booting.." , Vector(3736 , 660), self.PlayerTeam, GameActivity.ARROWUP);
				elseif self.ChunksComplete < 75 then
					self:AddObjectivePoint("Booting..." , Vector(3736 , 660), self.PlayerTeam, GameActivity.ARROWUP);
				else
					if self.BSOD then
						self:AddObjectivePoint(string.format("System Failure! Reboot required."), 
							Vector(3736 , 660), self.PlayerTeam, GameActivity.ARROWUP);
					else
						self:AddObjectivePoint(string.format("Booting: %d%%", self.ChunksComplete / self.TotalChunks * 100), 
							Vector(3736 , 660), self.PlayerTeam, GameActivity.ARROWUP);
					end
				end
			
				if self.GenericTimer:IsPastSimMS(self.ChunkInterval) then
					self.ChunksComplete = self.ChunksComplete + 1;
					self.BSOD = true;
					if self.ChunksComplete == 75 then
						-- To prevent quick occasional level completion
						-- BSOD the teleport certain times and then BSOD
						-- it at random with 50% probability
						if self.BootRetries >= self.MaxBootRetries then
							self.BSOD = false;
						else
							self.BootRetries = self.BootRetries + 1;
							self.BSOD = true;
						end
					end
					
					if self.BSOD then
						if self.ChunksComplete >= self.TotalChunks then
							print (string.format("BSOD Teleport Reseted %d of %d" , self.BootRetries , self.MaxBootRetries) );
							self.ChunksComplete = 0;
						end -- if
					else
						self.TeleportActive = true;
						print ("Teleport Activated");
						MovableMan:RemoveParticle(self.TeleportScreen);
						self.TeleportScreen = nil;
						self.TeleportScreen = CreateAEmitter("Active Screen");
						self.TeleportScreen.Pos = Vector(3735 , 716);
						self.TeleportScreen:EnableEmission(true);
						MovableMan:AddParticle(self.TeleportScreen);
						
						-- Turn on new teleport effects
						self.StartTeleportEffect = true;
						self.TeleportEffectTimer:Reset();
						self.TeleportEffectAsc = true;
					end

					self.GenericTimer:Reset();
				end -- if
			end -- if
		end -- if - else
	else
		self:TeleportEffect();
		for actor in MovableMan.Actors do
			if actor.Team == self.PlayerTeam then
				if self.AreaTeleport:IsInside(actor.Pos) then
					actor:FlashWhite(1000);
					-- Create the teleportation effect for both teleporters in the set.
					local fxa = CreateAEmitter("Teleporter Effect A");
					fxa.Pos = actor.Pos;
					MovableMan:AddParticle(fxa);
					if not (self.ActivityState == Activity.OVER) then
						if actor:HasObject("Artifact") then
							self.WinnerTeam = self.PlayerTeam;
							ActivityMan:EndActivity();
							self.EvacuateComplete = true;
							-- Tell the script to stop running for brains as the game has ended.
							for player = 0, self.PlayerCount - 1 do
								self.braindead[player] = true;
							end
						end
					end
					MovableMan:RemoveActor(actor);
					break;
				end
			end
		end -- for
	end
end
-----------------------------------------------------------------------------------------
-- That's all folks!
-----------------------------------------------------------------------------------------






















